package fr.curie.BiNoM.cytoscape.utils;
/*
   BiNoM Cytoscape Plugin under GNU Lesser General Public License 
   Copyright (C) 2010-2011 Institut Curie, 26 rue d'Ulm, 75005 Paris - FRANCE  
*/
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.List;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
/**
 * A dialog box to select strings in a sorted list displaying selected strings
 * 
 * @author Daniel.Rovera@curie.fr
 */
public class ListDialog extends GridBagDialog implements ActionListener,ListSelectionListener{
	private static final long serialVersionUID = 1L;
	public static int cx[]={0,0,1,0,1};
	public static int cy[]={0,1,1,2,2};
	public static int cw[]={2,1,1,1,1};
	public static int ch[]={1,1,1,1,1};
	public static int xw[]={0,9,9,1,1};
	public static int yw[]={0,9,9,0,0} ;
	public static int cf[]={H,B,B,H,H};
	final int width=360;
	final int height=480;
	private JButton okBouton, cancelBouton ;
	private boolean ok = false ;
	private JList listBox;
	private List list;
	public ListDialog(JFrame parent,String title, String label,String[]values){ 
		super(parent,title,true,cx,cy,cw,ch,xw,yw,cf);
		setSize(width,height);
		container=getContentPane();
		container.setLayout(new GridBagLayout());
		constraints = new GridBagConstraints();
		addWithConstraints(0,new JLabel(label));
		listBox = new JList(values);
		addWithConstraints(1,new JScrollPane(listBox));
		listBox.addListSelectionListener(this);
		list=new List();
		addWithConstraints(2,list);
		list.add("Select in the list");
		list.setFont(listBox.getFont());
		okBouton = new JButton ("OK") ;
		addWithConstraints(3,okBouton);		
		okBouton.addActionListener(this) ;
		cancelBouton = new JButton ("Cancel") ;
		addWithConstraints(4,cancelBouton) ;
		cancelBouton.addActionListener(this);
		addWindowListener(new WindowAdapter(){public void windowClosing(WindowEvent e){dispose();}});
	}
	public void launchDialog(ArrayList<String> values){
		ok = false ;
		listBox.clearSelection();
		setVisible(true) ;
		if(ok){
			Object[] valTemp = listBox.getSelectedValues();
			values.clear();
			for (int i = 0 ; i<valTemp.length ; i++) values.add((String)valTemp[i]); 
		}
	}
	public void actionPerformed (ActionEvent e){
		if (e.getSource()==okBouton){
			ok=true;
			dispose();
		}
		if (e.getSource()==cancelBouton) dispose();
	}
	public void valueChanged(ListSelectionEvent e) {
		if (!e.getValueIsAdjusting()){
			list.removeAll();
			Object[]val = listBox.getSelectedValues();
			for (int i=0; i<val.length ; i++) list.add((String)val[i]) ;
		}		
	}
}